;Trumpet Timer 2 - Portable Version - 1.5V Battery Operated  for Brian Lamb -- April 27, 2010
;
;
;  1). Push the button once to turn unit on. (OFF LOOP:  light is initially off - turned on when button is pushed)

;  2). Push the button again and it starts counting up.  (COUNTUP LOOP:  light comes on and stays on until second
;             push of button)

;  3). Push the button again and it counts back down from where you stopped. (COUNTDOWN LOOP: Light goes out
;             indicating countdown has started)

;        A push of button while running this Countdown Loop will go to step 1 (off loop)


;  4). Light comes on telling you that you came back to zero. Light stays on until you push button again , and it starts at #2 again.

;  5). Press TWO times to turn unit off. Light blinks twice.


;~~~~~~~~~~~~~~~~~~~~~~
;Trumpet Timer 4/19/2010 OLD Trumper Timer INSTRUCTIONS
;
;(1)  (OFF LOOP) (COUNT UP LOOP = 1a) Push button once to start COUNT UP 
;	Light comes on and stays on until COUNT UP is stopped by second push
;   of the button.  Step 2 immediately follows.
;

;(2) COUNT DOWN immediately starts for the same amount of time determined by the 
;    COUNT UP.  Light goes off..
;
;	Light remains off until COUNT DOWN is complete at which time, three one second flashes
;   will be seen.  At end of this COUNT DOWN, it moves back to step (1).

;	If at any time during this COUNT DOWN cycle the button is pushed, the COUNT DOWN
;	is aborted.  The light flashes three times to indicate the interruption and stop.
;   After flashes, unit goes to step (1) above --- to await the next new COUNT UP..


;NOTES:  The power strip toggle switch must be ON in order to power up the micro-controller.  When 
;	this is done, you will see four flashes of the light --- indicating it is ready for use.

;	MAXIMUM power load capability is 150 watts at one outlet.  If more than one outlet is
;   used, total wattage must not exceed 150 watts.
;
;	Total power while the strip is ON (with the light off) is a little over 1/3 watt -- very green.
;   If left on all year, 24 hours a day, 365 days a year, it would use about 35-cents worth of
;   power at a cost of 10 cents/KWH.  No power is consumed when the power strip toggle
;   switch is turned off.
;
;	DO NOT try to add an external push button switch.  This micro-controller circuit is
;   connected directly to the AC line thus, the wires to an external switch would be
;   dangerously "hot."  

;~~~~~~~~~~~~~~~~~~~~







;Internal oscillator of ATTINY2313 is running micro-controller at 1MHz (Divide by 8 in fuses selected)


;April 13, 2010

;R18 -- Global Flags Register


;r18,0(1) = Light on (1)  -- Light off (0)
;r18,1(2) = 1/50th second flag (generated by interrupt every 50th of a second)
;r18,2(4) = 1/1000th second flag generated by interrupt
;r18,3(8) = Countdown complete flag
;r18,4(16) = End of flashing of light routine flag
;r18,5(32) =
;r18,6(64) =
;r18,7(128) = 

;r0 = global 20 counter to generate 1/50th second flag during interrupt


.include "tn2313def.inc"

rjmp	START1
rjmp	START1
rjmp	START1
rjmp	START1
rjmp	ClockCntDwnInt		;1,000 interruptions per second
rjmp	START1
rjmp	START1

	
START1:				;set up stack pointer and initialize cold start

ldi		r16,low(RAMEND)		; Load low byte address of end of RAM into register R16
out		SPL,R16				; Initialize stack pointer to end of internal RAM

ldi		r16,7		;Set bits 0-3 for output
out		DDRA,r16	;Execute data direction with PA0-3 as output

clr		r16
out		PortA,r16	;turn off ports

ldi		r16,126		;Set bits PD1-6 to ones for out, bit PD0 for input
out		DDRD,r16	;Execute data direction with PD0 as input rest as output

clr		r16
out		PortD,r16	;All output ports low
					;No input resistor for input port D,0

ser		R16			;Set all bits for data direction as outputs
out		DDRB,R16	;execute data direction with all as outputs
clr		r16
out		PORTB,R16	;execute to set out ports low

in		r16,TIMSK	;enable 16-bit match to A register
ori		r16,64		
out		TIMSK,r16

in		r16,TCCR1B
ori		r16,9		; 1=no prescaling, 2=/8 prescaling, 3=/64 prescaling, etc. (NO prescaling used here)
out		TCCR1B,r16	;enable reset of counter to zero (bit3(8)) after match detection.
					;and bits 0,1,2 select prescaling source as no prescaling of clock

ldi		r16,3
out		OCR1AH,r16
ldi		r16,232		;For 1/1,000th second interrupt frequency, H=3, L=232
out		OCR1AL,r16	;loads the compare register A for 1/1,000th second interrupt
					;interval (1,000,000 Hz clock frequency)
					
sbi		PortB,2		;On power sustain line	

clr		r18			;clear flags register

rcall	Delay025	;allow power supply to reach full potential

ldi		r16,20
sts		$61,r16				;Store count of 20 for 50th counter and store in SRAM at $61

bset	7					;enable global interrupts

rjmp	TTT					;Start of program



;-----------------------------

ClockCntDwnInt: 	;interrupt occurs every 1,000th second\		
					
push	r16

in		r16,SREG	;save flags
sts		$60,r16

sbr		r18,4		;Set r18,2(4) bit = 1 1,1000 th Interrupt Occured Flag


CCDI1:

lds		r16,$61		;get previous count for 1/50th second flag
dec		r16
brne	CCDI2

ldi		r16,20
sbr		r18,2		;set 1/50th second flag, r18,1(2)


CCDI2:

sts		$61,r16

lds		r16,$60		;Get SREG values
out		SREG,r16	;Restore SREG flag values

pop		r16

reti				;Return from Interrupt


;----------------------------------------

Delay01:			;Delay .01 seconds - 1/100 second

push	r17
ldi		r17,5


D01a:

rcall	Delay001803 	;rcall delay of .001803 seconds
dec 	r17
brne	D01a

pop		r17
ret

;----------------------------------------


Delay025:			; 1/40th second delay

push	r17
ldi		r17,13


D025a:

rcall	Delay001803	;rcall .001803 delay
dec		r17
brne	D025a

pop		r17
ret


;----------------------------------

DelaySecond:

push	r17
ldi		r17,40


DSa:

rcall	Delay025
dec		r17
brne	DSa

pop		r17
ret


;-------------------------------------

Delay4Seconds:

push	r17
ldi		r17,4

D4Sa:

rcall	DelaySecond
dec		r17
brne	D4Sa

pop		r17
ret


;----------------------------------

Delay001803:		;A .001803 second delay

push	r17
clr		r17


D001803a:

dec		r17
brne	D001803a

pop		r17
ret


;-------------------------------------

;Variable Delays

;RCALL (3)


Delay13:
nop
Delay12:
nop
Delay11:
nop
Delay10:
nop
Delay9:
nop
Delay8:
nop
Delay7:
ret					;(4) (5 total if this line called)


;---------------------------------

ClearTimeCounter:

clr		r26
clr		r27
clr		r28
clr		r29
clr		r30
clr		r31

ret

;---------------------------------

IncrementCounter:
;1,000 counts per second
;60,000 counts per minute
;3,600,000 counts per hour
;86,400,000 counts per day
;3.1536 X10 per year
;Counter is capable of 2.814749767 X14 counts .... or 8,925 years

;  This counter capable of 2.8 X 14 or 8,925 years of 1000 counts per second

cbr		r18,4		;clear r18,2(4), 1/1000th second flag 

adiw	r26,1		;add one to r26,27 word
brcc	ICend

adiw	r28,1		;add one to r28,29 word
brcc	ICend

adiw	r30,1		;add one to r30,31 word


ICend:

ret


;---------------------------------

DecrementCounter:	;1/1000th second --  carry flag is set when it reaches overflow (zero)
					
cbr		r18,12		;clear r18,2(4), 1,000th second flag
					;clear also, r18,3(8) - countdown complete flag

sbiw	r26,1		;subtract one from r26,27 pair
brcc	DCend

sbiw	r28,1		;subtract one from r28,29 pair
brcc	DCend

sbiw	r30,1
brcc	DCend		;carry will be set if overflow occurs

sbr		r18,8		;set r18,3(8), countdown complete flag


DCend:

ret


;-----------------------------------------

;TRUMPET TIMER SECTION -- 4/24/2010

;-----------------------------------------

; This section coded 4/24/2010 to be both a trumpet timer and metronone

; New 4/24/2010 Instructions:

; A single flash is seen after turn on of main power switch.

; First push of button starts the up counter
; A second push stops up counter.  The interval of time between these to flashes
;    is captured.
; The unit immediately goes into and on/off mode of the light.  The light comes on
;    for the same time as the interval programmed between the first two button pushes.
; The light goes off for the same interval programmed.
; This on/off process continues until a single button push stops the timing cycle.

; When interrupted, the unit returns to the beginning.  It awaits a new two button
;    button push for different timing cycle,


;------------------------------------------

TTT:				;Modification for beep of sonalert instead of light on and off 4/25/2010 rws

sbi		PortB,0		;On Sonalert for short beep
ldi		r16,100		;Put delay on of Sonalert for 100/1000ths count
rcall	ClearTimeCounter	;zero time count


TTT1a:

sbrs	r18,2		;skip if r18,2(4) is set - 1/1000ths flag
rjmp	TTT1

rcall	IncrementCounter
dec		r16
brne	TTT1

cbi		PortB,0		;OFF sonalert


TTT1:

sbis	PIND,0		;skip if PIND,0 is set (switch off)
rjmp	TTT1a


TTT2:

sbrs	r18,2		;skip if r18,2(4) is set - 1/1000ths flag
rjmp	TTT2a

rcall 	IncrementCounter
dec		r16
brne	TTT2a

cbi		PortB,0		;Off sonalert


TTT2a:

sbic	PIND,0		;skip if PIND,0 is clear - switch is on
rjmp	TTT2


TTT20:				;STOP of up count and START of down count

sbi		PortB,0		;On sonalert for 1/40th second
rcall	Delay025
cbi		PortB,0		;Off sonalert - Beep to show stop of up count and start of down count


TTT4:				;Start down count

sbrs	r18,2		;skip if r18,2(4) set - 1/1000 interrupt completed
rjmp	TTT5

rcall	DecrementCounter
sbrc	r18,3		;skip if r18,3(8) clear - count not completed
rjmp	TTT26		;count has reached ZERO


TTT5:

sbis	PIND,0		;skip if PIND,0 is set - switch up
rjmp	TTT4		;jump back and wait for switch to go up


TTT21:				;switch now up and down count continues

sbrs	r18,2		;skip if r18,2(4) is set - 1/1000 interrupt completed
rjmp	TTT27

rcall	DecrementCounter
sbrs	r18,3		;skip if r18,3(8) is set - down count complete flag
rjmp	TTT27		;flag not set, go back to continue count down


TTT26:

rjmp	TimeUpBeeping


TTT27:

sbic	PIND,0		;skip if PIND,0 is clear - switch is down
rjmp	TTT21

sbi		PortB,0		;ON sonalert
rcall	Delay025
rcall	Delay025	;longer beep at shutdown

rjmp	PowerDown


;---------------------------------------

;Following is the end of sequence beeping

;---------------------------------------


TimeUpBeeping:		;Sets up short 1/10th second beeps and pauses -- r16 to contain length of beeps/pauses 
					;   r20 contains number of beeps

ldi		r16,250		;r16 = length of beep = 1/4 second
ldi		r20,6		;r20 = number of beeps/pauses


TUB1a:

sbis	PIND,0			;skip if PIND,0 is set -- switch is up
rjmp	PowerDown		;go back and recycle until switch goes up

sbi		PortB,0			;on sonalert


TUB2:

sbrs	r18,2		;skip if r18,2(4) is set -- 1000th flag
rjmp	TUB3

cbr		r18,4		;clear r18,2(4), 1000th flag
dec		r16
brne	TUB3

rcall	ToggleBeep

dec		r20
breq	TUB5

ldi		r16,250		;reset 250 count in r16 for lengh of beep length/pause
rjmp	TUB2	


TUB3:

sbis	PIND,0		;skip if PIND,0 is set -- switch is up
rjmp	PowerDown

rjmp	TUB2		;go through loop again

;--------------

TUB5:

cbi		PortB,0		;off beep
ldi		r20,10		;put r20, no. of beeps as 10, 20 second apart beeps


TUB5a:

rcall	ClearTimeCounter

ldi		r26,128		;set up timer for 20 second intervals
ldi		r27,79
ldi		r28,18


TUB5b:

sbrc	r18,2		;skip if r18,2(8) is clear -- 1000th flag
rjmp	TUB5c

sbis	PIND,0		;skip if PIND,0 is set -- switch is up
rcall	PowerDown


TUB5c:

rcall	DecrementCounter
sbrs	r18,3		;skip if r18,3(8) is set -- count reached zero flag
rjmp	TUB5b

cbr		r18,8		;clear r18,3(8) - count reached zero flag
sbi		PortB,0		;on sonalert
rcall	Delay025
cbi		PortB,0		;off sonalert

dec		r20			;decrement number of beeps counter
brne	TUB5a

rjmp	PowerDown


;----------------------------------------------

ToggleBeep:

sbis	PortB,0
rjmp	TB1

cbi		PortB,0			;off sonalert
rjmp	TBEnd


TB1:

sbi		PortB,0			;on sonalert


TBEnd:

ret

;--------------------------------

PowerDown:

cbi		PortB,0		;OFF beep
cbi		PortB,2		;OFF power sustain line

rjmp	PowerDown






